<?php

namespace Drupal\selectize\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\Plugin\Field\FieldWidget\EntityReferenceAutocompleteTagsWidget;
use Drupal\Core\Form\FormStateInterface;
use Drupal\selectize\SelectizeWidgetTrait;

/**
 * Plugin implementation of the 'selectize_widget' widget.
 *
 * @FieldWidget(
 *   id = "selectize_entity_reference_widget",
 *   label = @Translation("Autocomplete (Tags with selectize.js)"),
 *   field_types = {
 *     "entity_reference"
 *   },
 *   multiple_values = TRUE
 * )
 */
class SelectizeEntityReferenceWidget extends EntityReferenceAutocompleteTagsWidget {

  use SelectizeWidgetTrait;

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);
    $cardinality = $this->fieldDefinition->getFieldStorageDefinition()->getCardinality();
    $settings = $this->getSettings();
    $settings['maxItems'] = ($cardinality >= 1) ? $cardinality : NULL;
    $element['target_id']['#type'] = 'selectize_entity_autocomplete';
    if ($this->getSelectionHandlerSetting('auto_create') && ($bundle = $this->getAutocreateBundle())) {
      $settings['create'] = TRUE;
    }
    $element['target_id']['#settings'] = $settings;

    return $element;
  }

}
